net.sourceforge.pmd.lang.xml.rule

## Class AbstractXmlRule

- java.lang.Object
- - net.sourceforge.pmd.AbstractPropertySource
  - - net.sourceforge.pmd.lang.rule.AbstractRule
    - - net.sourceforge.pmd.lang.xml.rule.AbstractXmlRule

All Implemented Interfaces:
  ImmutableLanguage, PropertySource, Rule

Direct Known Subclasses:
  AbstractDomXmlRule

    public class AbstractXmlRule
    extends AbstractRule
    implements ImmutableLanguage

This is a base class for XML Java bases rules. Subclasses should override `visit(XmlNode, RuleContext)` and can call `super` to visit children.

### Field Summary

Fields
`static BooleanProperty` `COALESCING_DESCRIPTOR`
`static BooleanProperty` `EXPAND_ENTITY_REFERENCES_DESCRIPTOR`
`static BooleanProperty` `IGNORING_COMMENTS_DESCRIPTOR`
`static BooleanProperty` `IGNORING_ELEMENT_CONTENT_WHITESPACE_DESCRIPTOR`
`static BooleanProperty` `NAMESPACE_AWARE_DESCRIPTOR`
`static BooleanProperty` `VALIDATING_DESCRIPTOR`
`static BooleanProperty` `XINCLUDE_AWARE_DESCRIPTOR`

### Fields inherited from class net.sourceforge.pmd.AbstractPropertySource

`propertyDescriptors, propertyValuesByDescriptor`

### Fields inherited from interface net.sourceforge.pmd.Rule

`VIOLATION_SUPPRESS_REGEX_DESCRIPTOR, VIOLATION_SUPPRESS_XPATH_DESCRIPTOR`

### Constructor Summary

Constructors
Constructor and Description
`AbstractXmlRule()`

### Method Summary

Methods
`void` `apply(List<? extends Node> nodes, RuleContext ctx)` Apply this rule to the given collection of nodes, using the given context.
`ParserOptions` `getParserOptions()` This implementation returns a new instance of `ParserOptions` using default settings.
`protected void` `visit(XmlNode node, RuleContext ctx)`
`protected void` `visitAll(List<? extends Node> nodes, RuleContext ctx)`

### Methods inherited from class net.sourceforge.pmd.lang.rule.AbstractRule

`addExample, addRuleChainVisit, addRuleChainVisit, addViolation, addViolation, addViolation, addViolationWithMessage, addViolationWithMessage, addViolationWithMessage, deepCopyValuesTo, end, equals, getDescription, getExamples, getExternalInfoUrl, getLanguage, getMaximumLanguageVersion, getMessage, getMinimumLanguageVersion, getName, getPriority, getRuleChainVisits, getRuleClass, getRuleSetName, getSince, hashCode, isDeprecated, setDeprecated, setDescription, setExternalInfoUrl, setLanguage, setMaximumLanguageVersion, setMessage, setMinimumLanguageVersion, setName, setPriority, setRuleClass, setRuleSetName, setSince, setUsesDFA, setUsesTypeResolution, start, usesDFA, usesRuleChain, usesTypeResolution`

### Methods inherited from class net.sourceforge.pmd.AbstractPropertySource

`copyPropertyDescriptors, copyPropertyValues, definePropertyDescriptor, dysfunctionReason, getPropertiesByPropertyDescriptor, getProperty, getPropertyDescriptor, getPropertyDescriptors, hasDescriptor, ignoredProperties, setProperty, useDefaultValueFor, usesDefaultValues`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface net.sourceforge.pmd.PropertySource

`definePropertyDescriptor, dysfunctionReason, getPropertiesByPropertyDescriptor, getProperty, getPropertyDescriptor, getPropertyDescriptors, hasDescriptor, ignoredProperties, setProperty, useDefaultValueFor, usesDefaultValues`

### Field Detail

#### COALESCING_DESCRIPTOR

    public static final BooleanProperty COALESCING_DESCRIPTOR

#### EXPAND_ENTITY_REFERENCES_DESCRIPTOR

    public static final BooleanProperty EXPAND_ENTITY_REFERENCES_DESCRIPTOR

#### IGNORING_COMMENTS_DESCRIPTOR

    public static final BooleanProperty IGNORING_COMMENTS_DESCRIPTOR

#### IGNORING_ELEMENT_CONTENT_WHITESPACE_DESCRIPTOR

    public static final BooleanProperty IGNORING_ELEMENT_CONTENT_WHITESPACE_DESCRIPTOR

#### NAMESPACE_AWARE_DESCRIPTOR

    public static final BooleanProperty NAMESPACE_AWARE_DESCRIPTOR

#### VALIDATING_DESCRIPTOR

    public static final BooleanProperty VALIDATING_DESCRIPTOR

#### XINCLUDE_AWARE_DESCRIPTOR

    public static final BooleanProperty XINCLUDE_AWARE_DESCRIPTOR

### Constructor Detail

#### AbstractXmlRule

    public AbstractXmlRule()

### Method Detail

#### getParserOptions

    public ParserOptions getParserOptions()

Description copied from class: `AbstractRule`
This implementation returns a new instance of `ParserOptions` using default settings.

Specified by:
  `getParserOptions` in interface `Rule`
Overrides:
  `getParserOptions` in class `AbstractRule`
See Also:
  `Rule.setPriority(RulePriority)`

#### apply

    public void apply(List<? extends Node> nodes,
             RuleContext ctx)

Description copied from interface: `Rule`
Apply this rule to the given collection of nodes, using the given context.

Specified by:
  `apply` in interface `Rule`

#### visitAll

    protected void visitAll(List<? extends Node> nodes,
                RuleContext ctx)

#### visit

    protected void visit(XmlNode node,
             RuleContext ctx)